datablock ParticleData(GTOEngineParticle)
{
  dragCoefficient = 2;
  gravityCoefficient = -1;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0 0 0 0.3";
  colors[1] = "0 0 0 0";
  sizes[0] = 0.5;
  sizes[1] = 5;
  useInvAlpha = true;
};

datablock ParticleEmitterData(GTOEngineEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 4;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 20;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "GTOEngineParticle";
  useEmitterColors = true;
};

datablock ShapeBaseImageData(GTOEngineImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 9;

  stateName[0] = "Smoke";
  stateTransitionOnTimeout[0] = "Smoke";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 1000;
  stateEmitter[0] = GTOEngineEmitter;
  stateEmitterTime[0] = 1000;
};

datablock ParticleData(Gto_tireParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.4 0.4 0.4 0.3";
  colors[1] = "0.2 0.2 0.2 0";
  sizes[0] = 2;
  sizes[1] = 6;
  useInvAlpha = true;
};

datablock ParticleEmitterData(Gto_tireEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "Gto_tireParticle";
  useEmitterColors = true;
};

datablock ParticleData(Gto_vehicleDamageParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = -2;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0 0 0 0";
  colors[1] = "0 0 0 0.5";
  colors[2] = "0 0 0 0";
  sizes[0] = 3;
  sizes[1] = 4;
  sizes[2] = 6;
  times[0] = 0;
  times[1] = 0.2;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(Gto_vehicleDamageEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "Gto_vehicleDamageParticle";
  useEmitterColors = true;
};

//### Vehicle

datablock WheeledVehicleTire(Gto_Tire)
{
  shapeFile = "./GtoWheel.dts";
  mass = 5;
  radius = 0.85;
  staticFriction = 2;
  kineticFriction = 2.5;
  restitution = 1;
  lateralForce = 18000;
  lateralDamping = 4000;
  lateralRelaxation = 0.01;
  longitudinalForce = 14000;
  longitudinalDamping = 2000;
  longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleSpring(Gto_Spring)
{
  length = 0.2;
  force = 4000; //3000:
  damping = 700; //600;
  antiSwayForce = 4; //3;
};

datablock DebrisData(Gto_TireDebris)
{
  shapeFile = "./Wheel.dts";
  lifetime = 2;
  minSpinSpeed = -400;
  maxSpinSpeed = 200;
  elasticity = 0.5;
  friction = 0.2;
  numBounces = 3;
  staticOnMaxBounce = true;
  snapOnMaxBounce = false;
  fade = true;
  gravModifier = 2;
};

datablock ExplosionData(Gto_Explosion : vehicleExplosion)
{
  debris = Gto_TireDebris;
  debrisNum = 4;
  debrisNumVariance = 0;
  debrisPhiMin = 0;
  debrisPhiMax = 360;
  debrisThetaMin = 40;
  debrisThetaMax = 85;
  debrisVelocity = 14;
  debrisVelocityVariance = 3;
};

datablock ProjectileData(Gto_ExplosionProjectile : vehicleExplosionProjectile)
{
  uiName = "";
  explosion = Gto_Explosion;
};

datablock WheeledVehicleData(Gto_Vehicle)
{
  uiName = "GTO";
  category = "Vehicles";
  displayName = "";
  shapeFile = "./GTO.dts";
  emap = true;
  minMountDist = -2;
  numMountPoints = 4;
  mountThread[0] = "sit"; mountThread[1] = "sit"; mountThread[2] = "sit"; mountThread[3] = "sit"; mountThread[4] = "sit";
  maxDamage = 200;
  destroyedLevel = 200;
  speedDamageScale = 1.04;
  collDamageThresholdVel = 20;
  collDamageMultiplier = 0.02;
  massCenter = "0 0 -0.5";
  maxSteeringAngle = 0.8;
  integration = 4;
  tireEmitter = Gto_tireEmitter;
  cameraRoll = false;
  cameraMaxDist = 13;
  cameraOffset = 6;
  cameraLag = 0;
  cameraDecay = 0.75;
  cameraTilt = 0.4;
  collisionTol = 0.1;
  contactTol = 0.1;
  useEyePoint = false;
  defaultTire = Gto_Tire;
  defaultSpring = Gto_Spring;
  numWheels = 4;
  mass = 300;
  density = 5;
  drag = 1.2;
  bodyFriction = 0.6;
  bodyRestitution = 0.6;
  minImpactSpeed = 10;
  softImpactSpeed = 10;
  hardImpactSpeed = 15;
  groundImpactMinSpeed = 10;
  engineTorque = 1500;
  engineBrake = 500;
  brakeTorque = 3000;
  maxWheelSpeed = 38;
  rollForce = 900;
  yawForce = 600;
  pitchForce = 1000;
  rotationalDrag = 0;
  maxEnergy = 100;
  jetForce = 3000;
  minJetEnergy = 30;
  jetEnergyDrain = 2;
  splash = vehicleSplash;
  splashVelocity = 4;
  splashAngle = 67;
  splashFreqMod = 300;
  splashVelEpsilon = 0.6;
  bubbleEmitTime = 1.4;
  splashEmitter[0] = vehicleFoamDropletsEmitter;
  splashEmitter[1] = vehicleFoamEmitter;
  splashEmitter[2] = vehicleBubbleEmitter;
  mediumSplashSoundVelocity = 10;
  hardSplashSoundVelocity = 20;
  exitSplashSoundVelocity = 5;
  softImpactSound = slowImpactSound;
  hardImpactSound = fastImpactSound;
  justcollided = 0;
  rideable = true;
  lookUpLimit = 0.5;
  lookDownLimit = 0.5;
  paintable = true;
  damageEmitter[0] = Gto_vehicleDamageEmitter;
  damageEmitterOffset[0] = "0 4 1";
  damageLevelTolerance[0] = 0.5;
  damageEmitter[1] = VehicleBurnEmitter;
  damageEmitterOffset[1] = "0 3 0";
  damageLevelTolerance[1] = 0.9;
  numDmgEmitterAreas = 1;
  initialExplosionProjectile = Gto_ExplosionProjectile;
  initialExplosionOffset = 0;
  burnTime = 4000;
  finalExplosionProjectile = vehicleFinalExplosionProjectile;
  finalExplosionOffset = 0;
  minRunOverSpeed = 4;
  runOverDamageScale = 25;
  runOverPushScale = 1.2;
  protectPassengersBurn = true;
  protectPassengersRadius = true;
  protectPassengersDirect = true;
};


//### Functions

function Gto_Vehicle::onAdd(%this,%obj)
{
  parent::onAdd(%this,%obj);
  %obj.setWheelPowered(0,true);
  %obj.setWheelPowered(1,true);
  %obj.setWheelPowered(2,true);
  %obj.setWheelPowered(3,true);
  GTOEngineCheck(%obj);
}

function GTOEngineCheck(%obj)
{
  %vehicle = %obj;
  %speed = vectorLen(%obj.getVelocity());
  if(!isObject(%obj)) return;
  if(!isObject(%obj.getMountNodeObject(0))) %obj.unMountImage(3);
  else if(%speed < 20)
    %obj.mountImage(GTOEngineImage,3);
  Schedule(2000,0,"GTOEngineCheck",%obj);
}